unit Zaklad;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Menus, ScktComp, DXDraws, StdCtrls, ImgList;

type
  TF_Hlavni = class(TForm)
    MM_Zaklad: TMainMenu;
    M_Connection: TMenuItem;
    PM_Login: TMenuItem;
    PM_LogOut: TMenuItem;
    N1: TMenuItem;
    PM_ConProperties: TMenuItem;
    CS_Hlavni: TClientSocket;
    PM_Stav: TMenuItem;
    M_Game: TMenuItem;
    PM_StartGame: TMenuItem;
    DXD_HraciPole: TDXDraw;
    IL_Robot: TImageList;
    GB_Tahy: TGroupBox;
    LB_Nabizene: TListBox;
    Label1: TLabel;
    Label2: TLabel;
    LB_Pouzit: TListBox;
    B_ToTahy: TButton;
    B_FromTahy: TButton;
    B_Play: TButton;
    procedure PM_LoginClick(Sender: TObject);
    procedure PM_LogOutClick(Sender: TObject);
    procedure PM_ConPropertiesClick(Sender: TObject);
    procedure PM_StavClick(Sender: TObject);
    procedure CS_HlavniConnect(Sender: TObject; Socket: TCustomWinSocket);
    procedure CS_HlavniConnecting(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure CS_HlavniDisconnect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure CS_HlavniError(Sender: TObject; Socket: TCustomWinSocket;
      ErrorEvent: TErrorEvent; var ErrorCode: Integer);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure PM_StartGameClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure CS_HlavniRead(Sender: TObject; Socket: TCustomWinSocket);
    procedure B_ToTahyClick(Sender: TObject);
    procedure B_FromTahyClick(Sender: TObject);
    procedure B_PlayClick(Sender: TObject);
  private
    { Private declarations }
  public
   procedure CreateClasses;
   procedure FreeClasses;

   function GetWidthLabel(Nazev:string;Font:String;Velikost:Integer):integer;
  end;

TRobotPos=record
 X,Y,Smer:Integer;
end;

THra=class
 ID:Cardinal;
 RobotPos:TRobotPos;
 PrijateMoznosti:string;

  procedure StartHry;
  procedure VypisMozosti;
  function GetRobotSmer(Smer:string):Integer;
  function GetPopisTah(Zkratka:String):string;
  function GetZkratkaTah(Popis:String):string;
  procedure ZobrazitPohyb;
end;

TKlient=class
 BufData:string;
 StavDat:Byte;

  procedure SendData(Data:string);
  procedure ZpracujData;
end;

TPloska=record
 Typ:string;
end;

THraciPole=class
  procedure Vykresli;
  procedure VykresliPozadi;
  procedure VykresliMrizku;
  procedure VykresliSymboly;
  procedure VykresliRobota;
  procedure VykresliPredpokladanouCastCesty(var X,Y:Integer;Smer,Policka:Integer);
end;

const
 _START = 'GET /start'+#13#10#13#10;
 _PLAY  = 'GET /kolo';
 _MRIZKA = 30;

var
  F_Hlavni: TF_Hlavni;
  Hra:THra;
  Klient:TKlient;
  HraciPlocha:array [0..19,0..19] of TPloska;
  HraciPole:THraciPole;

implementation

uses Pripojeni, Stav, StrUtils;

{$R *.dfm}

procedure TF_Hlavni.PM_LoginClick(Sender: TObject);
 begin
  CS_Hlavni.Open;
 end;//procedure

procedure TF_Hlavni.PM_LogOutClick(Sender: TObject);
 begin
  CS_Hlavni.Close;
 end;//procedure

procedure TF_Hlavni.PM_ConPropertiesClick(Sender: TObject);
 begin
  F_ConnectionSettings.ShowModal;
 end;//procedure

procedure TF_Hlavni.PM_StavClick(Sender: TObject);
 begin
  F_Stav.Show;
 end;//procedure

procedure TF_Hlavni.CS_HlavniConnect(Sender: TObject;
  Socket: TCustomWinSocket);
 begin
  F_Stav.M_Stav.Lines.Add('Pripojeno k serveru');
  PM_Login.Enabled          := false;
  PM_LogOut.Enabled         := true;
  PM_ConProperties.Enabled  := false;
 end;//procedure

procedure TF_Hlavni.CS_HlavniConnecting(Sender: TObject;
  Socket: TCustomWinSocket);
 begin
  F_Stav.M_Stav.Lines.Add('Prpbiha pripojovani k serveru');
 end;//procedure

procedure TF_Hlavni.CS_HlavniDisconnect(Sender: TObject;
  Socket: TCustomWinSocket);
 begin
  F_Stav.M_Stav.Lines.Add('Odpojeno k serveru');
  PM_Login.Enabled          := true;
  PM_LogOut.Enabled         := false;
  PM_ConProperties.Enabled  := true;
 end;//procedure

procedure TF_Hlavni.CS_HlavniError(Sender: TObject;
  Socket: TCustomWinSocket; ErrorEvent: TErrorEvent;
  var ErrorCode: Integer);
 begin
  F_Stav.M_Stav.Lines.Add('Chyba client socketu');
 end;//procedure

procedure TF_Hlavni.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
 begin
  CanClose := true;

  if (CS_Hlavni.Active) then
   begin
    Application.MessageBox('Aplikace neni odpojena od serveru - odpojte se prosim od serveru v nabidce "Pripojeni k serveru"','Nelze ukoncit',MB_OK OR MB_ICONWARNING);

    CanClose := false;
   end;//if CS_Hlavni.Active
 end;//procedure

procedure TF_Hlavni.PM_StartGameClick(Sender: TObject);
 begin
  Hra.StartHry;
 end;//procedure

//vytvareni
procedure TF_Hlavni.CreateClasses;
 begin
  Hra     := THra.Create;
  Klient  := TKlient.Create;
  HraciPole := THraciPole.Create;
 end;//procedure

//niceni
procedure TF_Hlavni.FreeClasses;
 begin
  Hra.Free;
  Klient.Free;
  HraciPole.Free;
 end;//procedure

procedure TF_Hlavni.FormCreate(Sender: TObject);
 begin
  F_Hlavni.CreateClasses;
 end;//procedure

procedure TF_Hlavni.FormClose(Sender: TObject; var Action: TCloseAction);
 begin
  F_Hlavni.FreeClasses;
 end;//procedure

//zacatek hry 
procedure THra.StartHry;
 begin
  Klient.SendData(_START);
  Klient.StavDat := 1;
 end;//procedure

procedure TKlient.SendData(Data:string);
 begin
  if (not F_Hlavni.CS_Hlavni.Active) then Exit;

  F_Hlavni.CS_Hlavni.Socket.SendText(Data);
  F_Stav.M_Stav.Lines.Add('Odeslano:'+Data);
 end;//procedure

procedure TKlient.ZpracujData;
var cyklus,cyklus2:Integer;
    PrijataData:TStrings;
    Radek:integer;
    Deleni:TStrings;
 begin
  F_Stav.M_Stav.Lines.Add('Prijata data:');
  F_Stav.M_Stav.Lines.Add(Klient.BufData);


  PrijataData := TStringList.Create;
  Deleni      := TStringList.Create;
  ExtractStrings([#13],[],PChar(Klient.BufData),PrijataData);

  case (Klient.StavDat) of
   1:begin
      ExtractStrings([' '],[],PChar(PrijataData[21]),Deleni);

      Hra.ID          := StrToIntDef(PrijataData[0],0);
      Hra.RobotPos.X      := StrToIntDef(Deleni[0],0);
      Hra.RobotPos.Y      := StrToIntDef(Deleni[1],0);
      Hra.RobotPos.Smer   := Hra.GetRobotSmer(Deleni[2]);
      Hra.PrijateMoznosti := PrijataData[22];
      F_Stav.M_Stav.Lines.Add('ID hry:'+IntToSTr(Hra.ID));

      repeat
        for cyklus2 := 0 to 19 do
         begin
          HraciPlocha[cyklus][cyklus2].Typ := LeftStr(PrijataData[cyklus+1],1);
          PrijataData[cyklus+1] := RightStr(PrijataData[cyklus+1],Length(PrijataData[cyklus+1])-1);
         end;//for cyklus2
       cyklus := cyklus + 1;
       until (cyklus >= 20);


      HraciPole.Vykresli;
      Hra.VypisMozosti;
     end;//case (StavDat = 1)
   2:begin
      if ((LeftStr(Klient.BufData,7) = 'Vyhrali') or (LeftStr(Klient.BufData,5) = 'Chyba')) then
       begin
        Application.MessageBox(PChar(Klient.BufData),'Oznameni serveru',MB_OK OR MB_ICONINFORMATION);
       end else begin
        Klient.StavDat := 1;       
        Klient.ZpracujData;
       end;
     end;//case (StavDat = 2)
  end;//case


  Klient.BufData := '';
  Klient.StavDat := 0;

  PrijataData.Free;
  Deleni.Free;  
 end;//procedure

procedure TF_Hlavni.CS_HlavniRead(Sender: TObject;
  Socket: TCustomWinSocket);
 begin
  Klient.BufData := Klient.BufData + Socket.ReceiveText;

  Klient.ZpracujData;
 end;//procedure

procedure THraciPole.Vykresli;
 begin
  HraciPole.VykresliPozadi;
  HraciPole.VykresliMrizku;
  HraciPole.VykresliSymboly;
  HraciPole.VykresliRobota;

  F_Hlavni.DXD_HraciPole.Surface.Canvas.Release;
  F_Hlavni.DXD_HraciPole.Flip;
 end;//procedure

procedure THraciPole.VykresliPozadi;
 begin
  F_Hlavni.DXD_HraciPole.Surface.Fill(clWhite);
 end;//procedure

procedure THraciPole.VykresliMrizku;
var cyklus:integer;
    Pozice:Integer;
 begin
  F_Hlavni.DXD_HraciPole.Surface.Canvas.Pen.Color   := clBlack;
  F_Hlavni.DXD_HraciPole.Surface.Canvas.Brush.Color := clWhite;

  Pozice := _MRIZKA;
  for cyklus := 0 to 18 do
   begin
    F_Hlavni.DXD_HraciPole.Surface.Canvas.MoveTo(Pozice,0);
    F_Hlavni.DXD_HraciPole.Surface.Canvas.LineTo(Pozice,(20*_MRIZKA));

    Pozice := Pozice + _MRIZKA;
   end;//for cyklus

  Pozice := _MRIZKA;
  for cyklus := 0 to 18 do
   begin
    F_Hlavni.DXD_HraciPole.Surface.Canvas.MoveTo(0,Pozice);
    F_Hlavni.DXD_HraciPole.Surface.Canvas.LineTo((20*_MRIZKA),Pozice);

    Pozice := Pozice + _MRIZKA;
   end;//for cyklus

  F_Hlavni.DXD_HraciPole.Surface.Canvas.Release;
  F_Hlavni.DXD_HraciPole.Flip;
 end;//procedure

procedure THraciPole.VykresliSymboly;
var cyklus,cyklus2:Integer;
    Left,Top:Integer;
 begin
  Left := 0;
  Top  := 0;

  for cyklus := 0 to 19 do
   begin
    Left := 0;
    for cyklus2 := 0 to 19 do
     begin
      if (HraciPlocha[cyklus][cyklus2].Typ = 'X') then
       begin
        F_Hlavni.DXD_HraciPole.Surface.Canvas.Pen.Color   := clBlack;
        F_Hlavni.DXD_HraciPole.Surface.Canvas.Brush.Color := clGreen;

        F_Hlavni.DXD_HraciPole.Surface.Canvas.Rectangle(Left,Top,Left+_MRIZKA+1,Top+_MRIZKA+1);
       end;//if HraciPlocha[cyklus][cyklus2].Typ = 'X
      if (HraciPlocha[cyklus][cyklus2].Typ = '$') then
       begin
        F_Hlavni.DXD_HraciPole.Surface.Canvas.Brush.Color := clWhite;
        F_Hlavni.DXD_HraciPole.Surface.Canvas.Font.Color  := clBlack;
        F_Hlavni.DXD_HraciPole.Surface.Canvas.Font.Name   := 'Arial';
        F_Hlavni.DXD_HraciPole.Surface.Canvas.Font.Size   := 18;

        F_Hlavni.DXD_HraciPole.Surface.Canvas.TextOut(Left+8,Top+2,'$');
       end;
      if (HraciPlocha[cyklus][cyklus2].Typ = '#') then
       begin
        F_Hlavni.DXD_HraciPole.Surface.Canvas.Pen.Color   := clBlack;
        F_Hlavni.DXD_HraciPole.Surface.Canvas.Brush.Color := clRed;

        F_Hlavni.DXD_HraciPole.Surface.Canvas.Rectangle(Left,Top,Left+_MRIZKA+1,Top+_MRIZKA+1);
       end;//if HraciPlocha[cyklus][cyklus2].Typ = 'X

      Left := Left + _MRIZKA;
     end;//for cyklus2
    Top := Top + _MRIZKA;
   end;//for cyklus
 end;//procedure

function TF_Hlavni.GetWidthLabel(Nazev:string;Font:String;Velikost:Integer):integer;
var L_Test:TLabel;
 begin
  Result := 0;
  L_Test            := TLabel.Create(F_Hlavni);
  L_Test.Caption    := Nazev;
  L_Test.AutoSize   := true;
  L_Test.Visible    := false;
  L_Test.Font.Name  := Font;
  L_Test.Font.Size  := Velikost;
  Result            := L_Test.Width;
  L_Test.Free;
 end;//function

function THra.GetRobotSmer(Smer:string):Integer;
 begin
  Result := -1;

  if (Smer = 'N') then Result := 0;
  if (Smer = 'R') then Result := 1;
  if (Smer = 'D') then Result := 2;
  if (Smer = 'L') then Result := 3;
 end;//fucntion

procedure THraciPole.VykresliRobota;
 begin
  F_Hlavni.IL_Robot.Draw(F_Hlavni.DXD_HraciPole.Surface.Canvas,(Hra.RobotPos.X-1)*_MRIZKA,(Hra.RobotPos.Y-1)*_MRIZKA,Hra.RobotPos.Smer);
 end;//procedure

procedure THra.VypisMozosti;
var cyklus:Integer;
 begin
  F_Hlavni.LB_Nabizene.Clear;
  F_Hlavni.LB_Pouzit.Clear;

  for cyklus := 1 to Length(Hra.PrijateMoznosti) do
   begin
    F_Hlavni.LB_Nabizene.Items.Add(Hra.GetPopisTah(Hra.PrijateMoznosti[cyklus]));
   end;//for cyklus

  F_Hlavni.B_FromTahy.Enabled := false;   
  F_Hlavni.GB_Tahy.Visible := true;
 end;//procedure

function THra.GetPopisTah(Zkratka:string):string;
 begin
  Result := '';

  if (Zkratka = '1') then Result := 'Vped o 1 polko';
  if (Zkratka = '2') then Result := 'Vped o 2 polka';
  if (Zkratka = '3') then Result := 'Vped o 3 polka';
  if (Zkratka = 'L') then Result := 'Otoen doleva o 90 stup';
  if (Zkratka = 'R') then Result := 'Otoen doprava o 90 stup';
  if (Zkratka = 'Z') then Result := 'Zpt o 1 polko';
 end;//fucntion

function THra.GetZkratkaTah(Popis:string):string;
 begin
  Result := '';

  if (Popis = 'Vped o 1 polko') then Result := '1';
  if (Popis = 'Vped o 2 polka') then Result := '2';
  if (Popis = 'Vped o 3 polka') then Result := '3';
  if (Popis = 'Otoen doleva o 90 stup') then Result := 'L';
  if (Popis = 'Otoen doprava o 90 stup') then Result := 'R';
  if (Popis = 'Zpt o 1 polko') then Result := 'Z';
 end;//fucntion

procedure TF_Hlavni.B_ToTahyClick(Sender: TObject);
 begin
  if (LB_Nabizene.ItemIndex = -1) then
   begin
    Application.MessageBox('Vyberte prvek','Chyba',MB_OK OR MB_ICONWARNING);
    Exit;
   end;

  F_Hlavni.LB_Pouzit.Items.Add(F_Hlavni.LB_Nabizene.Items.Strings[F_Hlavni.LB_Nabizene.ItemIndex]);
  F_Hlavni.LB_Nabizene.Items.Delete(F_Hlavni.LB_Nabizene.ItemIndex);


  if (F_Hlavni.LB_Pouzit.Items.Count = 5) then F_Hlavni.B_ToTahy.Enabled := false;
  F_Hlavni.B_FromTahy.Enabled := true;

  Hra.ZobrazitPohyb;
  HraciPole.Vykresli;
 end;//procedure

procedure TF_Hlavni.B_FromTahyClick(Sender: TObject);
 begin
  if (LB_Pouzit.ItemIndex = -1) then
   begin
    Application.MessageBox('Vyberte prvek','Chyba',MB_OK OR MB_ICONWARNING);
    Exit;
   end;

  F_Hlavni.LB_Nabizene.Items.Add(F_Hlavni.LB_Pouzit.Items.Strings[F_Hlavni.LB_Pouzit.ItemIndex]);
  F_Hlavni.LB_Pouzit.Items.Delete(F_Hlavni.LB_Pouzit.ItemIndex);


  if (F_Hlavni.LB_Pouzit.Items.Count = 0) then F_Hlavni.B_FromTahy.Enabled := false;
  F_Hlavni.B_ToTahy.Enabled := true;

  Hra.ZobrazitPohyb;
  HraciPole.Vykresli;  
 end;//procedure

procedure TF_Hlavni.B_PlayClick(Sender: TObject);
var cyklus:Integer;
    Pohyby:string;
 begin
  if (not F_Hlavni.CS_Hlavni.Active) then
   begin
    Application.MessageBox('Klient neni pripojen k serveru','Chyba',MB_OK OR MB_ICONERROR);
    Exit;
   end;


  Pohyby := '';
  for cyklus := 0 to F_Hlavni.LB_Pouzit.Items.Count-1 do
   begin
    Pohyby := Pohyby + Hra.GetZkratkaTah(F_Hlavni.LB_Pouzit.Items.Strings[cyklus]);
   end;//for cyklus

  Klient.SendData(_PLAY+'?id='+IntToStr(Hra.ID)+'&pohyby='+Pohyby+#13#10#13#10);
  Klient.StavDat := 2;

  F_Hlavni.B_ToTahy.Enabled := true;
 end;//procedure

procedure THra.ZobrazitPohyb;
var Pohyby:string;
    cyklus:Integer;
    aSmer,aX,aY:Integer;
 begin
  Pohyby := '';
  for cyklus := 0 to F_Hlavni.LB_Pouzit.Items.Count-1 do
   begin
    Pohyby := Pohyby + Hra.GetZkratkaTah(F_Hlavni.LB_Pouzit.Items.Strings[cyklus]);
   end;//for cyklus

  aSmer := Hra.RobotPos.Smer;
  aX    := Hra.RobotPos.X;
  aY    := Hra.RobotPos.Y;

  for cyklus := 1 to Length(Pohyby) do
   begin
    if (Pohyby[cyklus] = '1') then HraciPole.VykresliPredpokladanouCastCesty(aX,aY,aSmer,1);
    if (Pohyby[cyklus] = '2') then HraciPole.VykresliPredpokladanouCastCesty(aX,aY,aSmer,2);
    if (Pohyby[cyklus] = '3') then HraciPole.VykresliPredpokladanouCastCesty(aX,aY,aSmer,3);
    if (Pohyby[cyklus] = 'L') then
     begin
      aSmer := aSmer - 1;
      if (aSmer < 0) then aSmer := (4 + aSmer);
     end;//PohybL
    if (Pohyby[cyklus] = 'R') then
     begin
      aSmer := aSmer + 1;
      if (aSmer > 3) then aSmer := (aSmer - 3);
     end;//PohybR
    if (Pohyby[cyklus] = 'Z') then
     begin
      case (aSmer) of
       0:HraciPole.VykresliPredpokladanouCastCesty(aX,aY,2,1);
       1:HraciPole.VykresliPredpokladanouCastCesty(aX,aY,3,1);
       2:HraciPole.VykresliPredpokladanouCastCesty(aX,aY,0,1);
       3:HraciPole.VykresliPredpokladanouCastCesty(aX,aY,1,1);
       end;//case
     end;//PohybR
   end;//for cyklus
 end;//procedure


procedure THraciPole.VykresliPredpokladanouCastCesty(var X,Y:Integer;Smer,Policka:Integer);
var StartX,StartY,EndX,EndY:Integer;
 begin
 F_Hlavni.DXD_HraciPole.Surface.Canvas.Pen.Color := clBlack;
 F_Hlavni.DXD_HraciPole.Surface.Canvas.Brush.Color := clAqua;

  case (Smer) of
   0:begin
      Y := Y - 1;

      StartX := (X-1)*_MRIZKA;
      StartY := ((Y-1)*_MRIZKA)+_MRIZKA+1;
      EndX   := ((X-1)*_MRIZKA)+(_MRIZKA)+1;
      EndY   := ((Y-1)*_MRIZKA)-((Policka-1)*_MRIZKA);

      if ((F_Hlavni.DXD_HraciPole.Surface.Canvas.Pixels[EndX-5,EndY-35] = clGreen) or (F_Hlavni.DXD_HraciPole.Surface.Canvas.Pixels[EndX-5,EndY-35] = clRed)) then EndY := EndY + _MRIZKA;

      F_Hlavni.DXD_HraciPole.Surface.Canvas.Rectangle(StartX,StartY,EndX,EndY);

      Y := Y - Policka + 1;
     end;//smer = 0
   1:begin
      X := X + 1;

      StartX := (X-1)*_MRIZKA;
      StartY := (Y-1)*_MRIZKA;
      EndX   := ((X-1)*_MRIZKA)+(Policka*_MRIZKA)+1;
      EndY   := ((Y-1)*_MRIZKA)+_MRIZKA+1;

      if ((F_Hlavni.DXD_HraciPole.Surface.Canvas.Pixels[EndX-5,EndY-35] = clGreen) or (F_Hlavni.DXD_HraciPole.Surface.Canvas.Pixels[EndX-5,EndY-35] = clRed)) then EndX := EndX - _MRIZKA;
      
      F_Hlavni.DXD_HraciPole.Surface.Canvas.Rectangle(StartX,StartY,EndX,EndY);

      X := X + Policka - 1;
     end;//smer = 0
   2:begin
      Y := Y + 1;

      StartX := (X-1)*_MRIZKA;
      StartY := (Y-1)*_MRIZKA;
      EndX   := (((X-1)*_MRIZKA)+_MRIZKA)+1;
      EndY   := (((Y-1)*_MRIZKA))+(Policka*_MRIZKA)+1;

      if ((F_Hlavni.DXD_HraciPole.Surface.Canvas.Pixels[EndX-5,EndY-35] = clGreen) or (F_Hlavni.DXD_HraciPole.Surface.Canvas.Pixels[EndX-5,EndY-35] = clRed)) then EndY := EndY - _MRIZKA;


      F_Hlavni.DXD_HraciPole.Surface.Canvas.Rectangle(StartX,StartY,EndX,EndY);

      Y := Y + Policka - 1;
     end;//smer = 0
   3:begin
      X := X - 1;

      StartX := ((X-1)*_MRIZKA)+_MRIZKA+1;
      StartY := ((Y-1)*_MRIZKA);
      EndX   := ((X-1)*_MRIZKA)-((Policka-1)*_MRIZKA);
      EndY   := ((Y-1)*_MRIZKA)+_MRIZKA+1;

      if ((F_Hlavni.DXD_HraciPole.Surface.Canvas.Pixels[EndX-5,EndY-35] = clGreen) or (F_Hlavni.DXD_HraciPole.Surface.Canvas.Pixels[EndX-5,EndY-35] = clRed)) then EndX := EndX + _MRIZKA;

      F_Hlavni.DXD_HraciPole.Surface.Canvas.Rectangle(StartX,StartY,EndX,EndY);

      X := X - Policka + 1;
     end;//smer = 0
  end;
 end;//procedure


end.//unit
